import javax.xml.soap.*;
import javax.xml.messaging.*;
import java.io.*;
import java.util.*;

public class HelloWorldWS {
	public static void main(String[] args)	{
	try {
		SOAPConnectionFactory scFactory = SOAPConnectionFactory.newInstance();
		SOAPConnection con = scFactory.createConnection();

		MessageFactory factory = MessageFactory.newInstance();
		SOAPMessage message = factory.createMessage();

		SOAPPart soapPart = message.getSOAPPart();
		SOAPEnvelope envelope = soapPart.getEnvelope();

		SOAPHeader header = envelope.getHeader();
		SOAPBody body = envelope.getBody();
		 
		header.detachNode();

		//	Create an XML name with local name, name space and url
		Name bodyName = envelope.createName("helloworld2", 
							"ns1", "http://dcm.cl.uh.edu/yue/ws/helloworld2");
		SOAPBodyElement gltp = body.addBodyElement(bodyName);

		Name name = envelope.createName("name");
		SOAPElement param = gltp.addChildElement(name);
		if(args.length <= 0)
			param.addTextNode("Bun Yue");
		else
			param.addTextNode(args[0]);

		URLEndpoint endpoint = new URLEndpoint("http://dcm.cl.uh.edu/yue/courses/xml/notes/ws/HelloWorld2.asmx");
		SOAPMessage response = con.call(message, endpoint);
		con.close();

		SOAPPart sp = response.getSOAPPart();
		SOAPEnvelope se = sp.getEnvelope();
		SOAPBody sb = se.getBody();
		Iterator it = sb.getChildElements();
		while(it.hasNext()){
			SOAPBodyElement bodyElement = (SOAPBodyElement)it.next();
			Iterator it2 = bodyElement.getChildElements();
			while(it2.hasNext()){
				SOAPElement element2 = (SOAPElement)it2.next();
				String returnMessage = element2.getValue();
				System.out.print("The return message is ");
				System.out.println(returnMessage);
			}
		}

	} catch (Exception ex) {
		ex.printStackTrace();
	}
	}
}
